// Вычисление факториала с использованием библиотеки gmp и языка C
// Use to compile: gcc fact100lib.c -lgmp -o fact100libc
#include <stdlib.h>
#include <gmp.h>

int main(int argc, char* argv[]) {
    mpz_t result;
    unsigned long int x;
    if(argc !=2)
      x = 100;
    else
      x = atoi(argv[1]);
    mpz_init_set_ui(result, 1UL);

    unsigned long int i;
    for(i = 2; i <= x; i++) {
      mpz_mul_ui(result, result, i);
    }
    gmp_printf("%Zd\n", result);
    return 0;
}
