// Вычисление факториала с использованием действительных чисел
// Use to compile: c++ doubleFact.cpp -o doubleFact

double factorial(double n) {
    if (n < 2.0) return 1;
    double p = 1.0;
    for (double i = 2.0; i <= n; ++i) {
        p *= i;
    }
    return p;
}

#include <iostream>

int main() {
    std::cout << "100! = " << factorial(100.0) << std::endl;
    for(double i = 0.0; i < 20.0; ++i) {
        std::cout << i <<"! = " << factorial(i) << std::endl;
    }
    return 0;
}
