// Вычисление факториала с непосредственным использованием
// функции mpz_fac_ui, имеющейся в библиотеке gmp
// Use to compile: gcc fact100fun.c -lgmp -o fact100fun

#include <stdlib.h>
#include <gmp.h>
 
int main(int argc, char* argv[]) {
    mpz_t result;
    unsigned long int x;
    if(argc !=2)
      x = 100;
    else
      x = atoi(argv[1]);

    mpz_init(result);
    mpz_fac_ui(result, x);

    gmp_printf("%Zd\n", result);
    return 0;
}
