// Вычисление факториала с использованием библиотек gmp и gmpxx
// Use to compile: c++ fact100lib.cpp -lgmpxx -lgmp -o fact100libcpp

#include <cstdlib>
#include <iostream>
#include <gmpxx.h>
using namespace std;

int main(int argc, char* argv[]) {
    if(argc !=2) {
      cout << "Argumen is absent!!!" << endl;
      return -1;
    }
    mpz_class result(1UL);
    unsigned long int x = atoi(argv[1]);
    for(unsigned long int i = 2; i <= x; i++) {
      result *= i;
    }
    cout << result << endl;
    return 0;
}
