// Вычисление факториала с использованием беззнаковых целых
// Use to compile: c++ unsignedFact.cpp -o unsignedFact

unsigned factorial(unsigned n) {
    if (n < 2) return 1;
    unsigned p = 1;
    for (unsigned i = 2; i <= n; ++i) {
        p *= i;
    }
    return p;
}

#include <iostream>

int main() {
    std::cout << "100! = " << factorial(100) << std::endl;
    for(unsigned i = 0; i < 20; ++i) {
        std::cout << i <<"! = " << factorial(i) << std::endl;
    }
    return 0;
}
